use super::MessageSpecies;

pub enum TemperatureMessage{
    GetTemp,            //Request   0x00; may contain TempParamSelect obj (Species Select:
                        //                  - Standard  = TempSimpleData obj
                        //                  - Data      = TempData obj )
                        //                  Default to TempSimpleData
    GetConfig,          //Request   0x01;
    PutTemp,            //Response  0x00; may contain TempSimpleData or TempData obj
    PutConfig,          //Response  0x01;
    WriteConfig,        //Command   0x00;
    ReportTemp,         //Status    0x00;
    GetEngStatus,       //Request   0x02;
    PutEngStatus,       //Response  0x02; requires TempEngData obj
    ReportEngStatus,    //Stream    0x00; requires TempEngData obj
    MsgPushEnable,      //Command   0x01; requires TempParamSelect obj
    MsgSetAlg,          //Command   0x02; requires TempParamSelect obj
    MsgSetMode,         //Command   0x03; requires TempParamSelect obj
    GetStatus,          //Request   0x03;
    PutStatus,          //Response  0x03; requires TempStat obj
    ReportStatus,       //Stream    0x01; requires TempStat obj
    ResetDevice,        //Command   0x04; no obj
    GetProbeInfo,       //Request   0x04; 
    PutProbeInfo,       //Response  0x04; requires TempProbeData obj
    GetCalib,           //Request   0x05;
    PutCalib,           //Response  0x05; requires TempCalConfig obj
    SetCalib,           //Command   0x05; requires TempCalConfig obj
    SaveCalib,          //Command   0x06; no obj
    LoadCalib,          //Command   0x07; no obj
    RestoreCalib,       //Command   0x08; no obj
    GetSettings,        //Request   0x06; 
    PutSettings,        //Response  0x06; Requires TempConfig obj
    SetSettings,        //Command   0x09; Requires TempConfig obj
    SaveSettings,       //Command   0x0a; no obj
    LoadSettings,       //Command   0x0b; no obj
    RestoreSettings,    //Command   0x0c; no obj
    GetHWState,         //Request   0x07; requires TempParamSelect obj
    PutHWState,         //Response  0x07; requires TempHWState obj
    SetHWState,         //Command   0x0d; requires TempHWState obj
    GetTestLock,        //Request   0x08; requires TempParamSelect obj
    PutTestLock,        //Response  0x08; requires TempLock obj
    SetTestLock,        //Command   0x0e; requires TempLock obj
    GetRawData,         //Request   0x09; 
    PutRawData,         //Response  0x09; requires TempRawData obj
    GetSample,          //Request   0x0a; 
    PutSample,          //Response  0x0a; requires TempSampleData obj
    ReportSample,       //Stream    0x02; requires TempSampleData obj
    GetTouch,           //Request   0x0b;
    PutTouch,           //Response  0x0b; Requires TempTouchData obj
    ReportTouch,        //Stream    0x03; requires TempTouchData obj
    GetTherm,           //Request   0x0c;
    PutTherm,           //Response  0x0c; Requires TempThermData obj
    SetTherm,           //Command   0x0f; Requires TempThermData obj
    ReportTherm,        //Stream    0x04; Requires TempThermData obj
    StartAcquire,       //Command   0x10; 
    StopAcquire,        //Command   0x11;
    GetThermSettings,   //Request   0x0d; Requires TempMsgArgs obj
    PutThermSettings,   //Response  0x0d; requires TempMsgArgs obj
    WriteThermSettings, //Command   0x12; requires TempMsgArgs obj
}

impl MessageSpecies for TemperatureMessage{}
