pub mod FmBATTERY_objects;
pub mod FmBODYMASSINDEX_objects;
pub mod FmCLINICIAN_objects;
pub mod FmCO2_objects;
pub mod FmCOMMAND_LINE_objects;
pub mod FmDATATRANSFER_objects;
pub mod FmDEVICE_objects;
//pub mod FmECG_objects;
pub mod FmERROR_objects;
pub mod FmNUMERIC_objects;
pub mod ecg_objects;
pub mod error_objects;
pub mod filesys_objects;
pub mod flash_objects;
pub mod him_objects;
pub mod height_objects;
pub mod hr_objects;
pub mod interp_object;
pub mod list_object;
pub mod location_objects;
pub mod module_objects;
pub mod network_objects;
pub mod nibp_objects;
pub mod numeric_objects;
pub mod wave_objects;
pub mod wave_sample_objects;

use crate::datatypes;
use downcast_rs::Downcast;

#[derive(Clone,Default,Debug)]
pub struct RawObject{
    id:u32,
    size:u32,
    version:u16,
    bitmask:u8,
    payload:Vec<u8>,
    crc:u16
}
impl RawObject{
    pub fn get_raw_id(&self) -> u32{ self.id.clone() }
    pub fn get_size(&self) -> u32 { self.size.clone() }
    pub fn get_version(&self) -> u16 { self.version.clone() }
    pub fn get_bitmask(&self) -> u8 { self.bitmask.clone() }
    pub fn get_payload(&self) -> Vec<u8> { self.payload.clone() }
    pub fn get_crc(&self) -> u16 { self.crc.clone() }
    pub fn calculate_crc(&self) -> u16 { todo!() }
    pub fn calculate_size(&self) -> u32 { todo!() }
}

pub trait Object: std::fmt::Debug + Downcast{
    fn get_raw_object(self: &Self) -> RawObject;
    fn get_family(self: &Self) -> datatypes::Family;
    fn get_genus(self: &Self) ->  datatypes::Genus;
    fn get_species(self: &Self) -> Box<dyn ObjectSpecies>;
}
pub trait ObjectSpecies: Downcast {}
downcast_rs::impl_downcast!(ObjectSpecies);
