use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmDTCOLLECTION:Downcast{}

#[derive(Clone,Debug)]
pub enum FmDTCOLLECTIONSpecies{
	SpMODULE,
	SpUSER,
	SpPATIENT,
	SpLEADMEASURE,
	SpWAVE,
	SpSPIRO,
	SpFILEDESCRIPTION,
	SpMEDS_STRINGS,
	SpCLINHIST_STRINGS,
	SpINTERP_STRINGS,
	SpINTERPRESULTS,
	SpCONTACTINFO_STRINGS,
	SpPATIENT_LIST,
	SpWIFI,
}
impl ObjectSpecies for FmDTCOLLECTIONSpecies{}

impl FmDTCOLLECTION for CColDModule{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDModule{
	colcmoduledstd:Object::CModuleDStd,
	colcmodulecstd:Object::CModuleCStd,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDModule {
	fn new() -> Self { todo!() }
}
impl Object for CColDModule{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDModule) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDUser{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDUser{
	colcuserdstd:Object::CUserDStd,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDUser {
	fn new() -> Self { todo!() }
}
impl Object for CColDUser{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDUser) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDPatient{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDPatient{
	colcpatientdstd:Object::CPatientDStd,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDPatient {
	fn new() -> Self { todo!() }
}
impl Object for CColDPatient{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDPatient) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDLeadMeas{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDLeadMeas{
	colcecgdleadmeas:Object::CECGDLeadMeas,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDLeadMeas {
	fn new() -> Self { todo!() }
}
impl Object for CColDLeadMeas{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDLeadMeas) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDWave{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDWave{
	cwaveconfig:Object::CWaveCStd,
	colcwavedstd:Object::CWaveDStd,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDWave {
	fn new() -> Self { todo!() }
}
impl Object for CColDWave{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDWave) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDSpiro{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDSpiro{
	colcspirodstd:Object::CSpiroDStd,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDSpiro {
	fn new() -> Self { todo!() }
}
impl Object for CColDSpiro{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDSpiro) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDFileDesc{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDFileDesc{
	colcfilesysdfiledesc:Object::CFileSysDFileDesc,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDFileDesc {
	fn new() -> Self { todo!() }
}
impl Object for CColDFileDesc{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDFileDesc) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDMedsStrings{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDMedsStrings{
	colcmoibstringdwide:Object::CMOIBStringDWide,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDMedsStrings {
	fn new() -> Self { todo!() }
}
impl Object for CColDMedsStrings{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDMedsStrings) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDClinHistStrings{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDClinHistStrings{
	colcmoibstringdwide:Object::CMOIBStringDWide,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDClinHistStrings {
	fn new() -> Self { todo!() }
}
impl Object for CColDClinHistStrings{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDClinHistStrings) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDInterpStrings{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDInterpStrings{
	colcmoibstringdwide:Object::CMOIBStringDWide,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDInterpStrings {
	fn new() -> Self { todo!() }
}
impl Object for CColDInterpStrings{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDInterpStrings) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDInterpResults{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDInterpResults{
	colcinterpdstd:Object::CInterpDStd,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDInterpResults {
	fn new() -> Self { todo!() }
}
impl Object for CColDInterpResults{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDInterpResults) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDContactInfo{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDContactInfo{
	colcmoibstringdwide:Object::CMOIBStringDWide,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDContactInfo {
	fn new() -> Self { todo!() }
}
impl Object for CColDContactInfo{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDContactInfo) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColDPatientList{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColDPatientList{
	colcpatientdethnic:Object::CPatientDEthnic,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColDPatientList {
	fn new() -> Self { todo!() }
}
impl Object for CColDPatientList{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColDPatientList) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmDTCOLLECTION for CColCWIFI{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CColCWIFI{
	colcnetworkcwifi:Object::CNetworkCWIFI,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CColCWIFI {
	fn new() -> Self { todo!() }
}
impl Object for CColCWIFI{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmDTCOLLECTION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnCONFIG }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmDTCOLLECTIONSpecies::CColCWIFI) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

