use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmINTERPRETATION:Downcast{}

#[derive(Clone,Debug)]
pub enum FmINTERPRETATIONSpecies{
	SpSTANDARD,
}
impl ObjectSpecies for FmINTERPRETATIONSpecies{}

impl FmINTERPRETATION for CInterpDStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CInterpDStd{
	modifieddate:chrono::NaiveDateTime,
	editedby:widechar,
	algorithm:Algorithm,
	reasonstatementsenabled:boolean,
	text:widechar,
	#[getter(skip)]
	raw_object:RawObject,
}

#[derive(Clone,Copy,Debug,Default)]
pub enum Algorithm{
	#[default]
	NONE,
	MEANS,
	USER,
	SPIROMETRY,
}

pub impl CInterpDStd {
	fn new() -> Self { todo!() }
}
impl Object for CInterpDStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmINTERPRETATION }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmINTERPRETATIONSpecies::CInterpDStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

