use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmLIST:Downcast{}

#[derive(Clone,Debug)]
pub enum FmLISTSpecies{
	SpSTANDARD,
	SpDESCRIPTION,
}
impl ObjectSpecies for FmLISTSpecies{}

impl FmLIST for CListCDesc{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CListCDesc{
	classid:uint32,
	totalnumelements:uint16,
	elementbytesize:uint32,
	listpacketsize:uint16,
	acceptednumelements:uint16,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CListCDesc {
	fn new() -> Self { todo!() }
}
impl Object for CListCDesc{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmLIST }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnCONFIG }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmLISTSpecies::CListCDesc) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

