use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmLOCATIONID:Downcast{}

#[derive(Clone,Debug)]
pub enum FmLOCATIONIDSpecies{
	SpSTANDARD,
}
impl ObjectSpecies for FmLOCATIONIDSpecies{}

impl FmLOCATIONID for CLocationIDCStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CLocationIDCStd{
	facility:widechar,
	building:widechar,
	floor:widechar,
	unit:widechar,
	room:widechar,
	bed:widechar,
	source:Source,
	#[getter(skip)]
	raw_object:RawObject,
}

#[derive(Clone,Copy,Debug,Default)]
pub enum Source{
	#[default]
	NONE,
	BOLTED_DOWN,
	HARD_WIRED,
	USER_ENTERED,
}

pub impl CLocationIDCStd {
	fn new() -> Self { todo!() }
}
impl Object for CLocationIDCStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmLOCATIONID }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnCONFIG }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmLOCATIONIDSpecies::CLocationIDCStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

