use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmMODULE:Downcast{}

#[derive(Clone,Debug)]
pub enum FmMODULESpecies{
	SpSTANDARD,
	SpHOST,
	SpHARDWARE,
	SpBOOTLOADER,
	SpBOOTRECOVERY,
	SpINITBOOTLOADER,
	SpOPERATINGSYSTEM,
	SpFONT,
	SpAUXILIARYHOST,
	SpAUXILIARYHARDWARE,
	SpAUXILIARYBOOTLOADER,
	SpAUXILIARYOPERATINGSYSTEM,
	SpNIBPMODULE,
	SpNIBPSAFETYALG,
	SpNIBPSTEPALG,
	SpNIBPFASTALG,
	SpNIBPNEONATSTEPALG,
	SpNIBPPOEMALG,
	SpNIBPSTEPAOALG,
	SpTEMPMODULE,
	SpSURETEMPALG,
	SpSPO2MODULE,
	SpECGMODULE,
	SpMEANS,
	SpSPIROMETRY,
	SpCO2MODULE,
	SpFRONTEND,
	SpPPP,
	SpSECUREDIGITALCARD,
	SpPRINTER,
	SpCOMMSMODULE,
	SpRADIO,
	SpBARCODE,
	SpSCALE,
	SpBATTERY,
	SpSPHBMODULE,
	SpSPMETMODULE,
	SpSPOCMODULE,
	SpSPCOMODULE,
	SpRESPIRATIONMODULE,
	SpIDS,
	SpPATIENTMOTIONMODULE,
	SpCUSTOMDATAMODULE,
	SpMAINMCU,
	SpAUXILLARYMCU,
	SpBLUETOOTH,
	SpPRMODULE,
	SpALL,
	SpSENSOR,
	SpMODULE,
}
impl ObjectSpecies for FmMODULESpecies{}

impl FmMODULE for CModuleDStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CModuleDStd{
	version:ansichar,
	description:ansichar,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CModuleDStd {
	fn new() -> Self { todo!() }
}
impl Object for CModuleDStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmMODULE }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmMODULESpecies::CModuleDStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmMODULE for CModuleDExtStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CModuleDExtStd{
	modulecontainer:Object::ANY_CLASS,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CModuleDExtStd {
	fn new() -> Self { todo!() }
}
impl Object for CModuleDExtStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmMODULE }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATAEXT }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmMODULESpecies::CModuleDExtStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmMODULE for CModulePSelector{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CModulePSelector{
	speciesselector:uint32,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CModulePSelector {
	fn new() -> Self { todo!() }
}
impl Object for CModulePSelector{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmMODULE }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnPARAMETER }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmMODULESpecies::CModulePSelector) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

