use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmORDER:Downcast{}

#[derive(Clone,Debug)]
pub enum FmORDERSpecies{
	SpSTANDARD,
}
impl ObjectSpecies for FmORDERSpecies{}

impl FmORDER for COrderDExtStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct COrderDExtStd{
	orderid:widechar,
	clientid:widechar,
	serviceid:ServiceID,
	status:Status,
	container:Object::ANY_CLASS,
	#[getter(skip)]
	raw_object:RawObject,
}

#[derive(Clone,Copy,Debug,Default)]
pub enum ServiceID{
	#[default]
	NONE,
	RESTING_ECG_12_LEAD,
	SPIRO_FVC,
	SPIRO_BD_RESPONSE,
	SPIRO_SVC,
	SPIRO_MVV,
}

#[derive(Clone,Copy,Debug,Default)]
pub enum Status{
	#[default]
	NONE,
	NEW_ORDER,
	ACCEPT_ORDER,
	DECLINED_ORDER,
	COMPLETE,
	COMPLETE_RESULTS,
	ACCEPT_COMPLETE_RESULTS,
}

pub impl COrderDExtStd {
	fn new() -> Self { todo!() }
}
impl Object for COrderDExtStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmORDER }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATAEXT }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmORDERSpecies::COrderDExtStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

