use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmPRINTER:Downcast{}

#[derive(Clone,Debug)]
pub enum FmPRINTERSpecies{
	SpSTANDARD,
}
impl ObjectSpecies for FmPRINTERSpecies{}

impl FmPRINTER for CPrinterCStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CPrinterCStd{
	internalprinter:boolean,
	printerpaper:PrinterPaper,
	externalprinter:boolean,
	printertype:PrinterType,
	printgridenabled:boolean,
	#[getter(skip)]
	raw_object:RawObject,
}

#[derive(Clone,Copy,Debug,Default)]
pub enum PrinterPaper{
	#[default]
	PAPER_PLAIN,
	PAPER_LABELS,
}

#[derive(Clone,Copy,Debug,Default)]
pub enum PrinterType{
	#[default]
	DEFAULT,
}

pub impl CPrinterCStd {
	fn new() -> Self { todo!() }
}
impl Object for CPrinterCStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmPRINTER }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnCONFIG }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmPRINTERSpecies::CPrinterCStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

