use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmQUERY:Downcast{}

#[derive(Clone,Debug)]
pub enum FmQUERYSpecies{
	SpREQUEST,
	SpRESPONSE,
	SpSELECT,
}
impl ObjectSpecies for FmQUERYSpecies{}

impl FmQUERY for CQueryDExtRqst{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CQueryDExtRqst{
	startindex:uint16,
	maxresults:uint16,
	select:Object::ANY_CLASS,
	clinician:Object::ANY_CLASS,
	response:uint32,
	guid:uint8,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CQueryDExtRqst {
	fn new() -> Self { todo!() }
}
impl Object for CQueryDExtRqst{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmQUERY }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATAEXT }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmQUERYSpecies::CQueryDExtRqst) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmQUERY for CQueryDExtRsp{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CQueryDExtRsp{
	remainingresults:boolean,
	return:Object::ANY_CLASS,
	guid:uint8,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CQueryDExtRsp {
	fn new() -> Self { todo!() }
}
impl Object for CQueryDExtRsp{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmQUERY }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATAEXT }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmQUERYSpecies::CQueryDExtRsp) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

impl FmQUERY for CQueryDExtSelect{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CQueryDExtSelect{
	memberid:uint16,
	classid:uint32,
	where:Object::ANY_CLASS,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CQueryDExtSelect {
	fn new() -> Self { todo!() }
}
impl Object for CQueryDExtSelect{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmQUERY }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATAEXT }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmQUERYSpecies::CQueryDExtSelect) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

