use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmRENDEZVOUS:Downcast{}

#[derive(Clone,Debug)]
pub enum FmRENDEZVOUSSpecies{
	SpSTANDARD,
}
impl ObjectSpecies for FmRENDEZVOUSSpecies{}

impl FmRENDEZVOUS for CRNDZDStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CRNDZDStd{
	deviceguid:uint8,
	ddsversion:uint16,
	data:uint8,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CRNDZDStd {
	fn new() -> Self { todo!() }
}
impl Object for CRNDZDStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmRENDEZVOUS }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmRENDEZVOUSSpecies::CRNDZDStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

