use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmTOC:Downcast{}

#[derive(Clone,Debug)]
pub enum FmTOCSpecies{
	SpSTANDARD,
	SpFLASHSECTOR,
}
impl ObjectSpecies for FmTOCSpecies{}

impl FmTOC for CTOCDStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CTOCDStd{
	sdatetime:chrono::NaiveDateTime,
	contents:uint32,
	#[getter(skip)]
	raw_object:RawObject,
}

pub impl CTOCDStd {
	fn new() -> Self { todo!() }
}
impl Object for CTOCDStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmTOC }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmTOCSpecies::CTOCDStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

