use crate::datatypes;
use super::{Object, ObjectSpecies, RawObject};
use derive_getters::Getters;
use derive_builder::Builder;
use downcast_rs::Downcast;

pub trait FmUSER:Downcast{}

#[derive(Clone,Debug)]
pub enum FmUSERSpecies{
	SpSTANDARD,
}
impl ObjectSpecies for FmUSERSpecies{}

impl FmUSER for CUserDStd{}
#[derive(Getters,Builder,Clone,Debug)]
pub struct CUserDStd{
	role:Role,
	passwordexpirationdays:uint16,
	passwordlastchanged:chrono::NaiveDateTime,
	isactiveuser:boolean,
	userguid:uint8,
	userid:widechar,
	username:widechar,
	password:widechar,
	#[getter(skip)]
	raw_object:RawObject,
}

#[derive(Clone,Copy,Debug,Default)]
pub enum Role{
	#[default]
	ADMINISTRATOR,
	USER,
}

pub impl CUserDStd {
	fn new() -> Self { todo!() }
}
impl Object for CUserDStd{
	fn get_family(&self) -> datatypes::Family { datatypes::Family::FmUSER }
	fn get_genus(&self) ->  datatypes::Genus { datatypes::Genus::GnDATA }
	fn get_species(&self) -> Box<dyn super::ObjectSpecies> { Box::new(FmUSERSpecies::CUserDStd) }
	fn get_raw_object(&self) -> RawObject { self.raw_object.clone() }
}

